import 'package:ev_framework/Elves/System/Ev_Func.dart';
import 'package:ev_framework/Elves/System/Ev_Page.dart';
import 'package:flutter/material.dart';

import '../Elves.dart';

enum  Ev_List_Select_Type { single,multi}


class Ev_List_Select extends StatelessWidget {
  List<Map> data;
  List sdata_array;
  bool select_close;

  var default_value;
  List default_multi_value;

  var select_type;
  var max_select;

  var onMaxerror;
  var onResult;

  double font_size;
  var font_color;

  var result;

  List result_multi;
  List result_multi_name;

  var color;
  Ev_Widget E = Ev_Widget();

  Ev_List_Select({this.sdata_array,this.select_type=Ev_List_Select_Type.single,this.color=Colors.blue,this.font_size=16,this.font_color=Colors.black ,this.default_value="",this.default_multi_value, this.max_select = 999999,this.onMaxerror,this.onResult,this.select_close=false}) {
    data = Ev_Func.sdata_list(sdata_array);
    result = default_value;

    if(default_multi_value == null)
    { result_multi = List();
    result_multi_name = List();
    }
    else
    {  result_multi = default_multi_value;
    }
  }

  @override
  Widget build(BuildContext context) {
    if(select_type == Ev_List_Select_Type.single)
      return single_container();
    else
      return multi_container();
  }

  Widget single_container()
  {  return ListView.separated(
    separatorBuilder: (context, index) => Divider(
      color: Colors.grey,
    ),
    itemCount: data.length,
    itemBuilder: (BuildContext build, int index) {
      var icon = default_value == data[index]["id"] ? Icon(Icons.check_circle,color:color,size: 25,) : Icon(Icons.fiber_manual_record,color:Colors.grey,size: 25);
      return ListTile(title: Text(data[index]["name"],style: TextStyle(fontSize: font_size,color:font_color),),trailing:
      E.Build.Widgets(key:data[index]["id"],widget: icon),
          onTap: (){
            if(result != null)
            { E.Widget[result].widget = Icon(Icons.fiber_manual_record,color:Colors.grey,size: 25,); }
            result =  data[index]["id"];
            E.Widget[result].widget = Icon(Icons.check_circle,color:color,size: 25,);
            if(onResult!=null)
            {  onResult(data[index]["id"],data[index]["name"]); }
            if(select_close)
            { Ev_Page.close(build); }
          });
    },);
  }

  Widget multi_container()
  {  return ListView.separated(
    separatorBuilder: (context, index) => Divider(
      color: Colors.grey,
    ),
    itemCount: data.length,
    itemBuilder: (BuildContext build, int index) {
      var icon = result_multi.contains(data[index]["id"]) ? Icon(Icons.check_box,color:color,size: 25,) : Icon(Icons.check_box_outline_blank,color:color,size: 25);


      return ListTile(title: Text(data[index]["name"],style: TextStyle(fontSize: font_size,color:font_color)),trailing:
      E.Build.Widgets(key:data[index]["id"],widget: icon),
          onTap: (){
            var id = data[index]["id"];
            if(result_multi.contains(id)) {
              Icon(Icons.check_box_outline_blank, color: color, size: 25);
              result_multi.remove(id);
              result_multi_name.remove(data[index]["name"]);
              E.Widget[data[index]["id"]].widget = Icon(Icons.check_box_outline_blank,color:color,size: 25,);
            }
            else {
              if(result_multi.length == max_select) {
                if (onMaxerror != null) {
                  onMaxerror();
                }
              }
              else {
                E.Widget[data[index]["id"]].widget = Icon(Icons.check_box, color: color, size: 25);
                result_multi.add(id);
                result_multi_name.add(data[index]["name"]);
              }
            }
            if(onResult!=null)
            {  var id = result_multi == null ? "" : result_multi.join(",");
            var name = result_multi_name == null ? "" : result_multi_name.join(",");
            onResult(id,name);
            }
          });
    },);
  }
}
