import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:http/http.dart' as http;

class Ev_API_badge extends StatefulWidget {
  var url;
  var post;
  var fontsize = 12.0;
  var fontcolor;
  var bgcolor;
  Ev_API_badge({this.url,this.post,this.fontsize=10,this.fontcolor=Colors.white,this.bgcolor=Colors.deepOrange});

  @override
  _Ev_API_badgeState createState() => _Ev_API_badgeState();
}

class _Ev_API_badgeState extends State<Ev_API_badge> {

  @override
  Widget build(BuildContext context) {

    return FutureBuilder(
      future: get_data(),
      builder: (BuildContext context, AsyncSnapshot<String> snapshot) {
        if(snapshot.connectionState == ConnectionState.done)
        { print("EV API Bade " + widget.url + " Done Date  : " + snapshot.data.toString());
        return badge(snapshot.data);
        }
        else
          return Container();
      },
    );
  }

  Widget badge(String sdata) {
    var count = int.parse(sdata);
    if (count > 0) {
      var textsize = (count > 99) ? widget.fontsize - 2 : widget.fontsize;
      var c = (count > 999) ? "99+" : "$count";

      return ClipOval(
        child: Container(
          height: widget.fontsize + 6,
          width: widget.fontsize + 6,
          color: widget.bgcolor,
          child: Center(child: Text(
              c, style: TextStyle(fontSize: textsize, color: widget.fontcolor),
              textAlign: TextAlign.center)),
        ),
      );
    }
    else
    {  return Container(); }
  }

  Future<String> get_data() async {
    http.Response response = await http.post(widget.url, body: widget.post);
    var decode =  jsonDecode(response.body.toString());
    return decode["sdata"]["count"];
  }


}